// using_logger_array.cpp 
//
/*
    Using the logger_array:
    logging to file, console, and Debug Window (win32)
*/

#include <boost/config.hpp>
#ifdef BOOST_MSVC
#pragma warning (disable : 4786)
#endif


// uncomment this, for the SMART_ASSERTs to behave just like
// in Release mode (that is, turning off SMART_ASSERTions)
//
// #define BOOST_SMART_ASSERT_MODE 0

#include <iostream>
#include <string>
#include <list>

#include "boost/smart_assert.hpp"
// extra (COOL) functions
#include "boost/smart_assert_ext.hpp"


using namespace boost::smart_assert;


void test_loggerarray() {

    int *one = 0;
    int *two = 0;
    int *three = 0;

    SMART_ASSERT(one);
    SMART_ASSERT(two);
    SMART_ASSERT(three);
}



// initialize the smart_assert library
namespace boost { namespace smart_assert {
smart_assert_initializer initializer( "./assert.txt", "./persist.txt", &default_initialize);
}}


void dump_summary_to_cout( const assert_context & context) {
    dump_assert_context_summary( context, std::cout );
}


int main()
{
    configs_array().run_config( "ignore");

    logger_array a;

    // existing logger
    assert_context_func to_file = assert_settings().get_logger();
    a.add_logger( to_file);
    // log to cout
    a.add_logger( &dump_summary_to_cout);
#if defined( BOOST_SMART_ASSERT_WIN32)
    // log to Dbg Window
    a.add_logger( &output_to_debug_wnd_win32);
#endif
    assert_settings().set_logger( 
        assert_context_func().assign( a));

    for ( int idx = 0; idx < 5; ++idx) 
        test_loggerarray();
    std::cout << "\nExample over. Press a non-space key." << std::endl;

    while ( isspace( std::cin.get() ));
    return 0;
}









